--[[
	News info plguin
]]--


--------------------------------------
-- Create plugin

local RW = LibStub("AceAddon-3.0"):GetAddon("Raid Watch")
local plugin = RW:Plugin("News")
if not plugin then return end

--------------------------------------
-- Locals
local UIF
local AceGUI
local news = {}

--------------------------------------
-- Init

function plugin:OnRegister()
	self.db = RW.db:RegisterNamespace("News", {profile={}})
end

function plugin:PluginEnable()
	UIF = LibStub("AceGUI-Factory-1.0"):GetFactory("RW")
	AceGUI = LibStub("AceGUI-3.0")
end

function plugin:PluginDisable()
end

--------------------------------------
-- Options
function plugin:GetOptions()
	return 98, "News", self.GetGUI
end

function plugin:GetGUI()
	self = self or plugin
	
	local group, label, color, check
	
	group = AceGUI:Create("ScrollFrame")
	group:SetLayout("Flow")
	
	label = UIF:MainTitleLabel("News")
	group:AddChild(label)
	
	local igroup = UIF:InlineGroup("")
	group:AddChild(igroup)	
	
	for title, data in pairs(news) do
		local newsGroup = UIF:InlineGroup2(title)
		igroup:AddChild(newsGroup)
		
		self:GetNewsAsGUI(newsGroup, data, "")
	end
	
	return group
end

function plugin:GetNewsAsGUI(group, data, level)
	for i, subData in pairs(data) do
		if type(subData) == "table" then
			group:AddChild(UIF:NormalText(level.."* "..i))
			plugin:GetNewsAsGUI(group, subData, level.."       ")
		else
			group:AddChild(UIF:NormalText(level.."- "..subData))
		end
	end
end

news["1.21 Alpha"] = {
	["ICC"] = {
		["Festergut"] = {
			"Added warning for Malleable Goo (HM)",
		}
	},
	["General"] = {
		"Added zhTW translation for ICC and CC.",
	},
}
news["1.20 Release"] = {
	"Change in folder structure, please delete all old folders that starts with \"RW_\", and also to keep saved variables you need to go into WTF \\Account \\[AccountName] \\SavedVariables \\ and rename RW_Core.lua -> RaidWatch.lua.",
	["ICC"] = {
		["The Lich King"] = {
			"Added warnings and marking for secondary targets of Necrotic Plague.",
			"Added marking on Val'kyrs (Mainly for 25man with 3 of them)",
			"Added marking of the person who will spawn a Raging Spirit.",
			"Added a message with the target of Defile so its easy to see who did not run properly!",
			"It should no longer report it as a wipe when everyone dies to Fury of Frostmourne.",
		},
		["Sindragosa"] = {
			"Added warning, cooldown and personal duration of Mystic Buffet. I will warn at 4 stacks.",
			"Change the sound of the warning when you get pulled in to the \"Come Closer\" warning, not optimal but at least a different sound from the Ice Tomb target warning sound.",
			"Raid marks for Frost Beacon should now be removed when the Beacon is removed.",
		},
		["Lady Deathwhisper"] = {
			"Add waves cooldown keep running in p2 in hard mode, and the CD is only 45s instead of 60.",
			"Added warning when Frostbolt is cast in hard modes.",
		},
		["Lord Marrowgar"] = {
			"Adjusted duration for bonestorm in hard mode, may be totally wrong.",
		},
		["Blood Prince Council"] = {
			"Fixed lua error when standing close to someone who is the target of Shock Vortex, the direction arrow should now pop up and point away from the person."
		},
	},
	["Other"] = {
		"New tab in the options \"News\". Will show the latest changes. Also if you do not have the latest version but someone in your guild or party have a higher version you will see what changes are in those version.",
	}
}
