local mod = RW:Boss("Valithria Dreamwalker", "Icecrown Citadel", "Frostwing Hall")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_shadeoferanikus]]
mod.SubCatIcon = [[Interface\Icons\achievement_dungeon_icecrown_frostwinghalls]]

------------------------------------
-- Variables

local tEnrage

-- Mana Void
local wManaVoid

-- Lay Waste
local wLayWaste, iLayWaste

-- Portals
local tPortalNext, wPortal

-----------------------------------
-- Init
function mod:OnRegister()
	L = mod:RegisterLocale("enUS")
	if L then		
		L.pull = "Heroes, lend me your aid. I... I cannot hold them off much longer. You must heal my wounds!"
		L.win = "I AM RENEWED! Ysera grant me the favor to lay these foul creatures to rest!"		
		L.yell_portals = "I have opened a portal into the Dream. Your salvation lies within, heroes..."
		
		L.show_health = "Show health bar for Valithra Dramwalker"
		
		L.next_portal = "Next portals"
		L.next_portal_opt = "Timer for next set of Portals"
		L.portal_warning = "Portals Up!"
		L.portal_warning_opt = "Warning when new portals spawn"
		L.portal_group = "Portals"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(L.pull, 36789, 37868, 36791, 37863, 37934, 37886, 37950, 37985)
	mod:SetWin(L.win)
	
	self:AddBoolOption("BossHealthbar", L.show_health, nl, true, select(3, GetSpellInfo(71189)))
	
	tEnrage			= self:BerserkTimer(420)
	
	-- Mana Void
	wManaVoid		= self:RunawayWarning(71179)
	
	-- Lay Waste
	wLayWaste		= self:CastWarning(69326)
	iLayWaste		= self:Icon("SKULL", 69326, false, nil, "CROSS")
	
	-- Portals
	tPortalNext		= self:CustomTimer(46, L.next_portal, L.next_portal_opt, 72482, L.portal_group)
	wPortal			= self:CustomWarning(L.portal_warning, L.portal_warning_opt, 72482, L.portal_group)
end

-----------------------------------------
-- Locals

-----------------------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("ManaVoid", 71179, 71741, 71086, 71743, 72029, 72030, 71085) -- 71085 may be the spell cast before they are summoned
	self:Track("LayWaste", 69325, 71730) -- 69325 and 71730 are channeled spells while the rest ar instant spells.

	self:YellTrack("Portals", L.yell_portals)
	
	if self.db.profile.BossHealthbar then
		self:SendMessage("RW_AddHealthFrame", "boss1", nil, nil, "UNIT")
	end
	
	tEnrage:Start()
end

function mod:ManaVoid(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wManaVoid:Show()
		end
	end
end

function mod:LayWaste(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wLayWaste:Show()
		iLayWaste:Show(args.dGUID)
	end
end

function mod:Portals(event, msg, name)
	tPortalNext:Start()
	wPortal:Show()
end