local mod = RW:Boss("Hodir", "Ulduar", "The Keepers of Ulduar")
local L

mod.BossIcon = [[Interface\Icons\spell_frost_manarecharge]]
mod.SubCatIcon = [[Interface\Icons\achievement_dungeon_ulduarraid_misc_05]]

---------------------------
-- Variables
local tFlashCD, tFlashCast, wFlash
local tFrozenDur
local tSpeedKill
local iStorm
local tBerserk

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.YellPull = "You will suffer for this trespass!"
		L.YellDeath = "I... I am released from his grasp... at last."
		end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 32845)
	self:SetWin(L.YellDeath, 32845)

	tFlashCD, tFlashCast, wFlash = self:CDTimer(41, 61968), self:CastTimer(61968), self:RunawayWarning(61968)
	tFrozenDur, wFrozen = self:DurTimer(20, 63512), self:CastWarning(63512)
	tSpeedKill = self:AchievementTimer(180, 3182)
	iStorm = self:Icon("SKULL", 65123, false, 30, "CROSS")
	tBerserk = self:BerserkTimer(475)
end

---------------------------
-- Locals


---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("FlashFreeze", 61968)
	self:Track("FrozenBlows", 62478, 63512)
	self:Track("StormCloud", 65123, 65133)

	tBerserk:Start()
	tSpeedKill:Start()	
end

function mod:FlashFreeze(event, args)
	if event == "SPELL_CAST_START" then
	 	tFlashCast:Start()
		wFlash:Show()
		tFlashCD:Schedule(9)
	end
end

function mod:FrozenBlows(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tFrozenDur:Start()
		wFrozen:Show()
	end
end

function mod:StormCloud(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			SendChatMessage("Stormcloud on me!", "SAY")
		end
		iStorm:Show(args.dName)
	end
end	